Index: trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpBrowserWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpBrowserWidget.cpp	(revision 89542)
+++ trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpBrowserWidget.cpp	(revision 89546)
@@ -191,4 +191,5 @@
     void sigFindInPageWidgetVisibilityChanged(bool fVisible);
     void sigHistoryChanged(bool fBackwardAvailable, bool fForwardAvailable);
+    void sigMouseOverImage(const QString &strImageName);
 
 public:
@@ -271,4 +272,5 @@
     void sigFindInPageWidgetVisibilityChanged(bool fVisible);
     void sigHistoryChanged(bool fBackwardAvailable, bool fForwardAvailable);
+    void sigMouseOverImage(const QString &strImageName);
 
 public:
@@ -710,4 +712,6 @@
     connect(m_pContentViewer, &UIHelpViewer::sigFindInPageWidgetToogle,
             this, &UIHelpBrowserTab::sltFindInPageWidgetVisibilityChanged);
+    connect(m_pContentViewer, &UIHelpViewer::sigMouseOverImage,
+            this, &UIHelpBrowserTab::sigMouseOverImage);
 
     m_pContentViewer->setSource(initialUrl);
@@ -939,8 +943,8 @@
     connect(pTabWidget, &UIHelpBrowserTab::sigHistoryChanged,
             this, &UIHelpBrowserTabManager::sigHistoryChanged);
-
-
-
-    pTabWidget->setZoomPercentage(zoomPercentage());
+   connect(pTabWidget, &UIHelpBrowserTab::sigMouseOverImage,
+            this, &UIHelpBrowserTabManager::sigMouseOverImage);
+
+   pTabWidget->setZoomPercentage(zoomPercentage());
     pTabWidget->setHelpFileList(m_helpFileList);
     setFocusProxy(pTabWidget);
@@ -1575,5 +1579,6 @@
     connect(m_pTabManager, &UIHelpBrowserTabManager::sigHistoryChanged,
             this, &UIHelpBrowserWidget::sltHistoryChanged);
-
+    connect(m_pTabManager, &UIHelpBrowserTabManager::sigMouseOverImage,
+            this, &UIHelpBrowserWidget::sltMouseOverImage);
 
     connect(m_pHelpEngine, &QHelpEngine::setupFinished,
@@ -1916,4 +1921,9 @@
 }
 
+void UIHelpBrowserWidget::sltMouseOverImage(const QString &strImageName)
+{
+    emit sigStatusBarMessage(QString("%1: %2").arg(tr("Click to enlarge the image")).arg(strImageName) , 3000);
+}
+
 void UIHelpBrowserWidget::sltCopyAvailableChanged(bool fAvailable)
 {
Index: trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpBrowserWidget.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpBrowserWidget.h	(revision 89542)
+++ trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpBrowserWidget.h	(revision 89546)
@@ -111,4 +111,5 @@
     void sltHistoryChanged(bool fBackwardAvailable, bool fForwardAvailable);
     void sltLinkHighlighted(const QString &strLink);
+    void sltMouseOverImage(const QString &strImageName);
 
 private:
Index: trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpViewer.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpViewer.cpp	(revision 89542)
+++ trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpViewer.cpp	(revision 89546)
@@ -660,11 +660,7 @@
 }
 
-
-void UIHelpViewer::mouseMoveEvent(QMouseEvent *pEvent)
-{
-    if (m_fOverlayMode)
-        return;
-
-    QPoint viewportCoordinates = viewport()->mapFromGlobal(pEvent->globalPos());
+void UIHelpViewer::setImageOverCursor(QPoint globalPosition)
+{
+    QPoint viewportCoordinates = viewport()->mapFromGlobal(globalPosition);
     QTextCursor cursor = cursorForPosition(viewportCoordinates);
     if (!m_fCursorChanged && cursor.charFormat().isImageFormat())
@@ -672,4 +668,5 @@
         m_fCursorChanged = true;
         viewport()->setCursor(m_handCursor);
+        emit sigMouseOverImage(cursor.charFormat().toImageFormat().name());
     }
     if (m_fCursorChanged && !cursor.charFormat().isImageFormat())
@@ -678,4 +675,12 @@
         m_fCursorChanged = false;
     }
+
+}
+
+void UIHelpViewer::mouseMoveEvent(QMouseEvent *pEvent)
+{
+    if (m_fOverlayMode)
+        return;
+    setImageOverCursor(pEvent->globalPos());
     QIWithRetranslateUI<QTextBrowser>::mouseMoveEvent(pEvent);
 }
@@ -995,4 +1000,6 @@
 void UIHelpViewer::clearOverlay()
 {
+    setImageOverCursor(cursor().pos());
+
     if (!m_fOverlayMode)
         return;
@@ -1038,4 +1045,5 @@
                 m_pOverlayBlurEffect->setEnabled(true);
             viewport()->setCursor(m_defaultCursor);
+            m_fCursorChanged = false;
             emit sigOverlayModeChanged(true);
             toggleFindInPageWidget(false);
Index: trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpViewer.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpViewer.h	(revision 89542)
+++ trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpViewer.h	(revision 89546)
@@ -52,4 +52,5 @@
     void sigZoomPercentageChanged(int iPercentage);
     void sigOverlayModeChanged(bool fEnabled);
+    void sigMouseOverImage(const QString &strImageName);
 
 public:
@@ -129,4 +130,5 @@
     void loadImageAtPosition(const QPoint &globalPosition);
     void clearOverlay();
+    void setImageOverCursor(QPoint globalPosition);
 
     const QHelpEngine* m_pHelpEngine;