Index: trunk/src/VBox/Devices/Audio/DrvHostAudioValidationKit.cpp
===================================================================
--- trunk/src/VBox/Devices/Audio/DrvHostAudioValidationKit.cpp	(revision 89583)
+++ trunk/src/VBox/Devices/Audio/DrvHostAudioValidationKit.cpp	(revision 89584)
@@ -89,4 +89,6 @@
     /** The list node. */
     RTLISTNODE             Node;
+    /** Index in test sequence (0-based). */
+    uint32_t               idxTest;
     /** Current test set entry to process. */
     PAUDIOTESTENTRY        pEntry;
@@ -122,4 +124,6 @@
     /** Current test set being handled. */
     AUDIOTESTSET        Set;
+    /** Number of total tests created. */
+    uint32_t            cTestsTotal;
     /** Number of tests in \a lstTestsRec. */
     uint32_t            cTestsRec;
@@ -258,8 +262,10 @@
     if (RT_SUCCESS(rc))
     {
-        LogRel(("Audio: Validation Kit: Registered guest recording test (%RU32ms, %RU64 bytes)\n",
-                pTestData->t.TestTone.Parms.msDuration, pTestData->t.TestTone.u.Rec.cbToWrite));
+        LogRel(("Audio: Validation Kit: Registered guest recording test #%RU32 (%RU32ms, %RU64 bytes)\n",
+                pThis->cTestsTotal, pTestData->t.TestTone.Parms.msDuration, pTestData->t.TestTone.u.Rec.cbToWrite));
 
         RTListAppend(&pThis->lstTestsRec, &pTestData->Node);
+
+        pTestData->idxTest = pThis->cTestsTotal++;
 
         pThis->cTestsRec++;
@@ -291,8 +297,10 @@
     if (RT_SUCCESS(rc))
     {
-        LogRel(("Audio: Validation Kit: Registered guest playback test (%RU32ms, %RU64 bytes)\n",
-                pTestData->t.TestTone.Parms.msDuration, pTestData->t.TestTone.u.Play.cbToRead));
+        LogRel(("Audio: Validation Kit: Registered guest playback test #%RU32 (%RU32ms, %RU64 bytes)\n",
+                pThis->cTestsTotal, pTestData->t.TestTone.Parms.msDuration, pTestData->t.TestTone.u.Play.cbToRead));
 
         RTListAppend(&pThis->lstTestsPlay, &pTestData->Node);
+
+        pTestData->idxTest = pThis->cTestsTotal++;
 
         pThis->cTestsPlay++;
@@ -512,5 +520,5 @@
                                     &Parms, &pTst->pEntry);
         if (RT_SUCCESS(rc))
-            rc = AudioTestSetObjCreateAndRegister(&pThis->Set, "guest-output.pcm", &pTst->pObj);
+            rc = AudioTestSetObjCreateAndRegister(&pThis->Set, "host-tone-rec.pcm", &pTst->pObj);
 
         if (RT_SUCCESS(rc))
@@ -533,5 +541,4 @@
         {
             pTst->t.TestTone.u.Play.cbRead += cbToRead;
-
             Assert(pTst->t.TestTone.u.Play.cbRead <= pTst->t.TestTone.u.Play.cbToRead);
 
@@ -613,5 +620,5 @@
                                     &Parms, &pTst->pEntry);
         if (RT_SUCCESS(rc))
-            rc = AudioTestSetObjCreateAndRegister(&pThis->Set, "host-input.pcm", &pTst->pObj);
+            rc = AudioTestSetObjCreateAndRegister(&pThis->Set, "host-tone-play.pcm", &pTst->pObj);
 
         if (RT_SUCCESS(rc))
@@ -794,14 +801,25 @@
 
         if (pThis->cTestsRec)
-            LogRel(("Audio: Validation Kit: Warning: %RU32 guest recording tests still outstanding\n", pThis->cTestsRec));
-        if (pThis->cTestsPlay)
-            LogRel(("Audio: Validation Kit: Warning: %RU32 guest playback tests still outstanding\n", pThis->cTestsPlay));
+            LogRel(("Audio: Validation Kit: Warning: %RU32 guest recording tests still outstanding:\n", pThis->cTestsRec));
 
         PVALKITTESTDATA pTst, pTstNext;
         RTListForEachSafe(&pThis->lstTestsRec, pTst, pTstNext, VALKITTESTDATA, Node)
+        {
+            size_t const cbOutstanding = pTst->t.TestTone.u.Rec.cbToWrite - pTst->t.TestTone.u.Rec.cbWritten;
+            if (cbOutstanding)
+                LogRel(("Audio: Validation Kit: \tRecording test #%RU32 has %RU64 bytes outstanding\n", pTst->idxTest, cbOutstanding));
             drvHostValKiUnregisterRecTest(pThis, pTst);
+        }
+
+        if (pThis->cTestsPlay)
+            LogRel(("Audio: Validation Kit: Warning: %RU32 guest playback tests still outstanding:\n", pThis->cTestsPlay));
 
         RTListForEachSafe(&pThis->lstTestsPlay, pTst, pTstNext, VALKITTESTDATA, Node)
+        {
+            size_t const cbOutstanding = pTst->t.TestTone.u.Play.cbToRead - pTst->t.TestTone.u.Play.cbRead;
+            if (cbOutstanding)
+                LogRel(("Audio: Validation Kit: \tPlayback test #%RU32 has %RU64 bytes outstanding\n", pTst->idxTest, cbOutstanding));
             drvHostValKiUnregisterPlayTest(pThis, pTst);
+        }
 
         Assert(pThis->cTestsRec == 0);